'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _ink = require('ink');

var _inkTextInput = require('ink-text-input');

var _inkTextInput2 = _interopRequireDefault(_inkTextInput);

var _readline = require('readline');

var _readline2 = _interopRequireDefault(_readline);

var _Conditional = require('./components/Conditional');

var _Conditional2 = _interopRequireDefault(_Conditional);

var _Container = require('./components/Container');

var _Container2 = _interopRequireDefault(_Container);

var _File = require('./util/File');

var _File2 = _interopRequireDefault(_File);

var _Zip = require('./util/Zip');

var _Zip2 = _interopRequireDefault(_Zip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class Cli extends _ink.Component {
    constructor(...args) {
        var _temp;

        return _temp = super(...args), this.state = {
            query: '',
            progress: 0,
            error: null,
            result: null,
            projectName: null
        }, this.handleChange = value => this.setState(state => ({
            query: value
        })), this.handleSubmit = async path => {
            try {
                const gitHubUrl = 'https://github.com/BlackBoxVision/typescript-hapi-starter/archive/master.zip';
                const gitHubFolderName = 'typescript-hapi-starter-master';

                const stream = await _Zip2.default.download(gitHubUrl);

                await _Zip2.default.writeStream(stream, path);
                await _Zip2.default.extract(path);
                await _Zip2.default.remove(path);

                await _File2.default.renameFolder(gitHubFolderName, path);

                this.setState(state => ({
                    projectName: path,
                    result: 'ok'
                }));
            } catch (error) {
                this.setState(state => ({
                    error: error
                }));
            }

            setTimeout(() => process.exit(0), 1000);
        }, _temp;
    }

    componentDidMount() {
        _readline2.default.emitKeypressEvents(process.stdin);
        process.stdin.setRawMode(true);
    }

    render(props, state) {
        return (0, _ink.h)(
            _Container2.default,
            null,
            (0, _ink.h)(
                _Conditional2.default,
                { expression: state.query.length >= 0 && !state.result },
                (0, _ink.h)(
                    _ink.Text,
                    { blue: true },
                    'Insert your project name:'
                ),
                (0, _ink.h)('br', null),
                (0, _ink.h)(_inkTextInput2.default, { value: state.query, onChange: this.handleChange, onSubmit: this.handleSubmit })
            ),
            (0, _ink.h)(
                _Conditional2.default,
                { expression: state.error },
                (0, _ink.h)(
                    _ink.Text,
                    { red: true },
                    state.error
                )
            ),
            (0, _ink.h)(
                _Conditional2.default,
                { expression: state.result === 'ok' },
                (0, _ink.h)(
                    _ink.Text,
                    { blue: true },
                    'Project ',
                    state.projectName,
                    ' has been created successfully.'
                )
            )
        );
    }

}
exports.default = Cli;