'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _isomorphicFetch = require('isomorphic-fetch');

var _isomorphicFetch2 = _interopRequireDefault(_isomorphicFetch);

var _unzip = require('unzip');

var _unzip2 = _interopRequireDefault(_unzip);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class ZipUtils {
    static async download(url) {
        const response = await (0, _isomorphicFetch2.default)(url, {
            method: 'GET',
            headers: {
                'Accept-Encoding': 'application/zip'
            }
        });

        return response.body;
    }

    static async writeStream(stream, value) {
        return new Promise((resolve, reject) => {
            stream.pipe(_fs2.default.createWriteStream(`${value}.zip`)).on('error', error => reject(error)).on('close', () => resolve('file written'));
        });
    }

    static async extract(path) {
        return new Promise((resolve, reject) => {
            _fs2.default.createReadStream(`${path}.zip`).pipe(_unzip2.default.Extract({ path: '.' })).on('error', error => reject(error)).on('close', _ => resolve('file written'));
        });
    }

    static async remove(path) {
        return new Promise((resolve, reject) => {
            _fs2.default.unlink(`${path}.zip`, error => {
                if (error) {
                    reject(error);
                }

                resolve();
            });
        });
    }
}
exports.default = ZipUtils;